@echo off
SET SERVER_IP_ADDRESS=192.168.1.2
SET IQN_ADDRESS=iqn.2008-12.com.ccboot.2:00
SET DISK_LETTER=D:

:: config msiscsi service
sc config msiscsi start= auto
for /f "skip=3 tokens=4" %%i in ('sc query msiscsi') do set "MSISCSI_STATUS=%%i" & goto next
:next
if /i NOT "%MSISCSI_STATUS%"=="RUNNING" net start msiscsi

:: disconnect all iscsi connections
for /f "usebackq delims=: tokens=2" %%i in (`iscsicli SessionList^|find /i "Session Id"`) do iscsicli LogoutTarget %%i

:: add new iscsi connection
iscsicli AddTargetPortal %SERVER_IP_ADDRESS% 3260
iscsicli LoginTarget %IQN_ADDRESS% T * * * * * * * * * * * * * * * 0

:: change original disk letter to z:
set ORIGINAL_DISK_VOL=NULL
if exist %DISK_LETTER% (
for /f %%i in ('mountvol %DISK_LETTER% /l') do set "ORIGINAL_DISK_VOL=%%i"
)

IF NOT %ORIGINAL_DISK_VOL% == NULL (
mountvol %DISK_LETTER% /d
mountvol Z: %ORIGINAL_DISK_VOL%
)

:: wait for iscsi disk
ping 127.0.0.1 -n 5

:: change iscsi disk letter
echo select disk 1 > c:\disk.txt
echo select partition 1 >> c:\disk.txt
echo remove all >> c:\disk.txt
echo assign letter=%DISK_LETTER% >> c:\disk.txt
echo exit >> c:\disk.txt
diskpart /s c:\disk.txt
del c:\disk.txt

ECHO =====================================================
ECHO           WRITTEN BY dereselcuk and Yao
ECHO           HAVE FUN! YOU ARE USING CCBOOT
ECHO                  www.ccboot.com 
ECHO =====================================================
pause